## Class: Charging Station
from Classes.Battery import Battery
from Classes.CSController import CSController


class ChargingStation:
	# Class variables


	# Instance variables
	def __init__(self, leg, ess_capacity, number_of_cells, line_input, line_output):
		self.line_input   = line_input
		self.line_output  = line_output
		
		# Power
		self.battery_power  = 0
		self.grid_power     = 0

		# Efficiency
		self.eff_board  = 0.99
		self.eff_trafo  = 0.98
		self.eff_conv   = 0.99
		self.battery    = Battery(ess_capacity, number_of_cells, line_input)
		self.controller = CSController(leg)

	def set_power(self, battery_power, grid_power):
		self.battery_power = battery_power*self.eff_board*self.eff_trafo*self.eff_conv
		self.grid_power    = grid_power*self.eff_board
		return None