## Class: Ferry
from Classes.Battery import Battery
from Classes.GenSet import GenSet
from Classes.FerryController import FerryController


class Ferry:
	# Class variables


	# Instance variables
	def __init__(self, ess_capacity, number_of_cells, line_input):
		self.line_input    = line_input

		# Power
		self.power = 0

		# Efficiency
		self.eff_board  = 0.99
		self.eff_trafo  = 0.98
		self.eff_conv   = 0.99

		# External
		self.cars          = 0
		self.passengers    = 0
		self.ferry_weight  = 0
		self.total_weight  = 0
		
		self.mode          = 'Nightlay'

		# Construct battery module in ferry
		self.battery = Battery(ess_capacity, number_of_cells, line_input)

		# Construct gen set module in ferry
		self.gen_set = GenSet()

		# Construct controller module in ferry
		self.controller = FerryController()

	def calculate_total_weight(self, cars, passengers):
		self.total_weight = self.ferry_weight + cars*1500 + passengers*75
		return None

	def set_power(self, power):
		self.power = power*self.eff_board*self.eff_trafo*self.eff_conv
		return None