import pandas as pd
import sqlite3
from sqlite3 import Error


db_file = 'C:\\Users\\noldu\\OneDrive\\NTNU\\Master thesis\\Application\\DB\\model.db'

class Manager:

	def dict_to_df(self, query_result,date=True):
		items = {
			val: dict(query_result["records"][val])
			for val in range(query_result["totalSize"])
			}
		df = pd.DataFrame.from_dict(items, orient="index").drop(["attributes"], axis=1)
		
		if date: # date indicates if the df contains datetime column
			df["CreatedDate"] = pd.to_datetime(df["CreatedDate"], format="%Y-%m-%d") # convert to datetime
			df["CreatedDate"] = df["CreatedDate"].dt.strftime('%Y-%m-%d') # reset string
		return df

	def get_ferry_data():
		try:
			conn = sqlite3.connect(db_file)
		except Error as e:
			print(e)
			return None

		with conn:
			data = pd.read_sql('SELECT * FROM '+'Ferry', conn)

		return data


	def get_cs_n_data():
		try:
			conn = sqlite3.connect(db_file)
		except Error as e:
			print(e)
			return None

		with conn:
			data = pd.read_sql('SELECT * FROM '+'cs_n', conn)

		return data


	def get_cs_s_data():
		try:
			conn = sqlite3.connect(db_file)
		except Error as e:
			print(e)
			return None

		with conn:
			data = pd.read_sql('SELECT * FROM '+'cs_s', conn)

		return data


	def get_el_cost_data():
		try:
			conn = sqlite3.connect(db_file)
		except Error as e:
			print(e)
			return None

		with conn:
			data = pd.read_sql('SELECT * FROM '+'el_cost', conn)

		return data

	def get_external_data():
		try:
			conn = sqlite3.connect(db_file)
		except Error as e:
			print(e)
			return None

		with conn:
			data = pd.read_sql('SELECT * FROM '+'ExternalData', conn)

		return data