## Cars and passenger statistics on ferry

# Import modules
import numpy as np
import matplotlib.pyplot as plt

times       = np.linspace(0, 23, 24)
pcu_working = [5.0, 0.0 ,0.0 ,0.0, 0.0, 8.5, 77.5, 198.0, 119.2, 101.4, 80.2, 110.2, 90.7, 90.5, 122.2, 157.4, 171.2, 103.3, 66.5, 35.3, 50.4, 24.8, 16.6, 8.2]
pcu_weekend = [6.0, 1.0, 0.0, 0.0, 0.0, 0.0, 8.9, 12.0, 20.8, 37.7, 41.4, 36.4, 55.3, 54.4, 64.9, 53.2, 55.2, 60.6, 47.3, 55.5, 43.0, 25.5, 10.6, 6.1]

crossings_working = [2, 0, 0, 0, 0, 2, 3, 4, 4, 4, 4, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 2, 2, 2]
crossings_weekend = [4, 0, 0, 0, 0, 0, 2, 2, 3, 4, 4, 3, 4, 4, 4, 4, 2, 4, 2, 4, 2, 2, 2, 2]

pcu_weekend_flag = False


def plot_pcu_stat():
	# data to plot
	n_groups = 24

	# create plot
	fig, ax = plt.subplots()
	index = np.arange(n_groups)
	bar_width = 0.35
	opacity = 0.8

	rects1 = plt.bar(index, pbe_working, bar_width,
	alpha=opacity,
	color='b',
	label='Working days')

	rects2 = plt.bar(index + bar_width, pbe_weekend, bar_width,
	alpha=opacity,
	color='g',
	label='Weekend')

	plt.xlabel('Hour', fontsize='16')
	plt.ylabel('PCU', fontsize='16')
	plt.title('Variation of PCUs', fontsize='16')
	plt.xticks(index + bar_width, ('00', '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23'))
	plt.legend()

	plt.tight_layout()
	plt.grid(False)
	plt.show()


def set_weekend_flag():
	global pcu_weekend_flag
	pcu_weekend_flag = True
	print('Weekend flag (EL): ', pcu_weekend_flag)


def get_statistical_pcus(time):
	if pcu_weekend_flag == True:
		crossings = crossings_weekend[int(time)]
		hourly_pcus = pcu_weekend[int(time)]
	else:
		crossings   = crossings_working[int(time)]
		hourly_pcus = pcu_working[int(time)]

	if crossings == 0:
		return 0
	else:
		return hourly_pcus/crossings


def get_random_pcus(time):
	if pcu_weekend_flag == True:
		crossings = crossings_weekend[int(time)]
		hourly_pcus = pcu_weekend[int(time)]
	else:
		crossings   = crossings_working[int(time)]
		hourly_pcus = pcu_working[int(time)]

	## Standard deviation in normal distribution function
	sigma = 3

	if crossings == 0:
		pcus = 0
	else:
		pcus = hourly_pcus/crossings

	pcu_random  = np.random.normal(pcus, sigma)
	return int(pcu_random)