## Create profile database from excel file

import pandas as pd
import xlrd
from datetime import datetime as dt
from datetime import timedelta as td
from datetime import date, time
import sqlite3
from sqlite3 import Error

# Load data
file = "C:\\Users\\noldu\\OneDrive\\NTNU\\Master thesis\\Application\\Profiles\\Profile C\\ProfileWeekend.xlsx"
xl = pd.read_excel(file)

# Initalize lists
datetime_list      = []
mode_list          = []
leg_list           = []
genset_power_list  = []
battery_power_list = []
hotel_power_list   = []



# Get date and time
d = date(2018, 2, 19)
for data in xl['Time']:
	t = data
	if t == time(00,00,00):
		d = d + td(days=1)
	datetime_list.append(dt.combine(d,t))

# Get modes
for data in xl['Mode']:
	mode_list.append(data)

# Get legs
for data in xl['Leg']:
	leg_list.append(data)

# Get genset data
for data in xl['Genset Power']:
	genset_power_list.append(data)


# Get battery power data
for data in xl['Propulsion Power']:
	battery_power_list.append(data)


for data in xl['Hotel Power']:
	hotel_power_list.append(data)


# Create connection to database
db_file = "C:\\Users\\noldu\\OneDrive\\NTNU\\Master thesis\\Application\\Profiles\\Profile C\\profileC.db"
try:
	conn = sqlite3.connect(db_file)
	print("Successfull conncetion to database")
except Error as e:
	print(e)


# Add data to database
for i in range(0, len(datetime_list)):
	data = (datetime_list[i], mode_list[i], leg_list[i], genset_power_list[i], battery_power_list[i], hotel_power_list[i])
	
	with conn:
		sql = ''' INSERT INTO Profile(datetime,mode,leg,genSetPower,propulsionPower,hotelPower) VALUES(?,?,?,?,?,?) '''
		cur = conn.cursor()
		cur.execute(sql, data)