## Create profile database from excel file

import pandas as pd
import xlrd
from datetime import datetime as dt
from datetime import timedelta as td
import sqlite3
from sqlite3 import Error

# Load data
file = "C:\\Users\\noldu\\OneDrive\\NTNU\\Master thesis\\Application\\Profiles\\Profile X\\profileX.xlsx"
xl = pd.read_excel(file)

# Initalize lists
datetime_list      = []
mode_list          = []
genset_power_list  = []
battery_power_list = []
hotel_power_list   = []



# Get date and time
datetime_start = dt(2019, 1, 25, 3, 00, 00)
for data in xl['Min']:
	datetime = datetime_start + td(minutes=data)
	datetime_list.append(datetime)


# Get modes
for data in xl['Mode']:
	mode_list.append(data)

# Get genset data
for data in xl['Genset 1']:
	genset_power_list.append(data)


# Get battery power data
for data in xl['Power Battery']:
	battery_power_list.append(data)


for data in xl['Hotel Power']:
	hotel_power_list.append(data)


# Create connection to database
db_file = "C:\\Users\\noldu\\OneDrive\\NTNU\\Master thesis\\Application\\Profiles\\Profile X\\profileX.db"
try:
	conn = sqlite3.connect(db_file)
	print("Successfull conncetion to database")
except Error as e:
	print(e)


# Add data to database
for i in range(0, len(datetime_list)):
	data = (datetime_list[i], mode_list[i], genset_power_list[i], battery_power_list[i], hotel_power_list[i])
	
	with conn:
		sql = ''' INSERT INTO ProfileX(datetime,mode,genSetPower,batteryPower,hotelPower) VALUES(?,?,?,?,?) '''
		cur = conn.cursor()
		cur.execute(sql, data)